#ifndef __MMU_H__
#define __MMU_H__

#include <inttypes.h>

#define ATTR_U0 0x8000
#define ATTR_U1 0x4000
#define ATTR_U2 0x2000
#define ATTR_U3 0x1000
#define ATTR_W  0x0800
#define ATTR_I  0x0400
#define ATTR_M  0x0200
#define ATTR_G  0x0100
#define ATTR_E  0x0080
#define ATTR_UX 0x0020
#define ATTR_UW 0x0010
#define ATTR_UR 0x0008
#define ATTR_SX 0x0004
#define ATTR_SW 0x0002
#define ATTR_SR 0x0001

typedef struct
{
	uint8_t valid;
	uint8_t ts;
	uint32_t base_effective_addr;
	uint8_t tid;
	uint64_t base_physical_addr;
	uint8_t size;
	uint16_t attr;
} page_t;

extern void mmu_init();
extern uint32_t get_page_size(uint32_t length);
extern uint32_t get_page_byte_length(uint32_t page_size);
extern uint32_t align_address_on_page_boundary(uint32_t addr, uint32_t page_size);
extern void load_tlb(page_t *page);

#endif
